'' SEPLAC (SANNAJ'S EXAMPLE PROGRAMMING LANGUAGE TO ASSEMBLY COMPILER)
'' FREEBASIC_WRITTEN COMPILER PROF OF CONCEPT

''' seplac-ast.bi - Global header for accessing the AST

' AST = abstract syntax tree

#include once "seplac.bi"               ' Global Header

extern AST_stringTable as string

enum ' Operation
    operation_add
    operation_sub
    operation_mul
    operation_div
    operation_assign
    operation_scani
    operation_printi
    operation_printS
end enum

'' Seplac AST
:type AST_protonode as AST_node

type AST_node_value
    varID as integer
    dataInt as integer
end type

type AST_node_operation
    alphaOp as AST_protonode ptr
    betaOp as AST_protonode ptr
    opType as byte
    'index as integer
end type

type AST_node_StringPrint
    dataString as zstring ptr
    stgid as integer
end type

type AST_node_program
    first as AST_protonode ptr
    last as AST_protonode ptr
end type

type AST_node
    prevEl as AST_node ptr
    nextEl as AST_node ptr
    union
        value as AST_node_value
        operation as AST_node_operation
        StringPrint as AST_node_StringPrint
        program as AST_node_program
    end union
end type

extern ASTtree as AST_node
extern currNode as AST_node ptr
extern STDD
