'' SEPLAC (SANNAJ'S EXAMPLE PROGRAMMING LANGUAGE TO ASSEMBLY COMPILER)
'' FREEBASIC_WRITTEN COMPILER PROF OF CONCEPT

''' seplac-symtab.bi - header for the string and variable symtable

#include once "SingleLinkedList.bas"    ' Link List Support

#define DECODE_ID_ERROR 144  ' We need some high errornum.

enum										' Byte code opcodes
	' Formart: memnoric<number of operants>
	bcopc_invalid
	bcopc_mov2 ' p1 = p2
	bcopc_add3 ' p1 = p2 + p3
	bcopc_add2 ' p1 += p2
	bcopc_sub3 ' 
	bcopc_sub2
	bcopc_mul3
	bcopc_mul2
	bcopc_div3
	bcopc_div2
	bcopc_pri0 ' Print var0
	bcopc_sci0 ' Get Data into var0
	bcopc_prs1 ' Print string
	bcopc_end0 ' Exit program
	
	bcopc_Max
end enum

type bcInstr field = 1				' A between code instruction
	bcopcode as short	
    operantType(1 to 2) as byte     ' Type 0 = Immedate; Type -1 = VariableID
    operantData(2) as integer
end type

type sym_var
	label as string
	initvalue as integer
end type


' Prototyping references to the 3 Symboltables
_declare_single_link_list(bcInstr)
'_declare_single_link_list(sym_var)
_declare_single_link_list(string)

extern bciSymtable as bcInstr_sllistt ptr
extern varSymtable as string_sllistt ptr
extern strSymtable as string_sllistt ptr

extern currentInstructionEl as bcInstr_sllistt ptr
extern currentVariableEl as string_sllistt ptr
extern currentStringEl as string_sllistt ptr

extern selectedInstruction as bcInstr ptr
extern TablelError as integer

declare function getVarID(label as string, initvalue as integer = 0) as integer ' Returns index
declare function addBytecodeInstruction() as integer
declare function addStringTableEntry(strConstant as string) as integer

declare function decodeParam(ID as integer, pType as byte) as string
